# these packages are not configured to run as a server
Name:          apacheds
Version:       1.5.7
Release:       11%{?dist}
Summary:       Apache Directory Server
License:       ASL 2.0
Url:           http://directory.apache.org/
# svn export http://svn.apache.org/repos/asf/directory/apacheds/tags/1.5.7/ apacheds-1.5.7
# tar czf apacheds-1.5.7-src-svn.tar.gz apacheds-1.5.7
Source0:       %{name}-%{version}-src-svn.tar.gz
# remove unavailable / unused deps
# fix bouncycastle gId aId
Patch0:        %{name}-%{version}-fixbuild.patch
# add maven-surefire-plugin version
Patch1:        %{name}-%{version}-i18n-pom.patch

BuildRequires: directory-project

BuildRequires: apache-commons-io
BuildRequires: apache-mina
BuildRequires: apacheds-ldap-client
BuildRequires: apacheds-shared
BuildRequires: bouncycastle
BuildRequires: junit
BuildRequires: ldapjdk >= 0:4.18-11
BuildRequires: log4j12
BuildRequires: slf4j
BuildRequires: mvn(org.slf4j:jcl-over-slf4j)
BuildRequires: mvn(org.slf4j:slf4j-api)
BuildRequires: mvn(org.slf4j:slf4j-log4j12)

# BuildRequires: antlr
# BuildRequires: apache-commons-cli
# BuildRequires: apache-commons-collections
# BuildRequires: apache-commons-daemon
# BuildRequires: apache-commons-dbcp
# BuildRequires: apache-commons-lang
# BuildRequires: apache-commons-pool
# BuildRequires: apacheds-daemon-bootstrappers
# BuildRequires: java-service-wrapper
# BuildRequires: jboss-system
# BuildRequires: jetty
# BuildRequires: maven
# BuildRequires: maven-xbean-plugin
# BuildRequires: plexus-utils
# BuildRequires: quartz
# BuildRequires: springframework-beans
# BuildRequires: springframework-context
# BuildRequires: springframework-core 
# BuildRequires: velocity
# BuildRequires: xbean-spring 
# BuildRequires: xerces-j2

# test deps
BuildRequires: apache-commons-net

BuildRequires: maven-local
BuildRequires: maven-antrun-plugin
BuildRequires: maven-dependency-plugin
BuildRequires: maven-source-plugin
BuildRequires: maven-surefire-provider-junit

BuildArch:     noarch

%description
ApacheDS is an extensible and embeddable directory server
entirely written in Java, which has been certified LDAPv3
compatible by the Open Group. Besides LDAP it supports
Kerberos 5 and the Change Password Protocol. It has been
designed to introduce triggers, stored procedures, queues and
views to the world of LDAP which has lacked these rich
constructs.

%package core
Summary:       ApacheDS Core

%description core
Server's core contains the JNDI provider, interceptors,
schema, and database subsystems. The core is the heart
of the server without protocols enabled.
- A linked in memory AVL tree implementation with Cursor.
- Contains classes that store interfaces with various
constants in ApacheDS.
Cursor interfaces used by the server core.
Server side LDAP entry classes.
Integration testing framework for Apache Directory Server.
Contains a JNDI provider implementation which wraps the
core so existing applications based on JNDI can use the
server embedded transparently. Remote and local run-time
operations will appear and feel exactly the same with a
performance boost when local. All operations via this
JNDI provider bypass the LDAP stack to perform operations
directly on the ApacheDS core.
A collection of tools as plugins to manage various tasks
associated with the directory server.
Shared classes between the core plugin and the core to
prevent cyclic dependencies since the core uses the core
plugin.
A linked in memory splay tree implementation with Cursor.
Core unit tests. 

%package i18n
Summary:       ApacheDS I18n

%description i18n
Internationalization of errors and other messages.

%package jdbm
Summary:       ApacheDS specific JDBM Implementation

%description jdbm
A specific JDBM Implementation.
A JDBM entry store which does not have any dependency on
core interfaces. The JDBM partition will use this store
and build on it to adapt this to server specific partition
interfaces. Having this separate module without
dependencies on core interfaces makes it easier to avoid
cyclic dependencies between modules. This is especially
important for use within the bootstrap plugin which needs
to build the schema partition used for bootstrapping the
server. 

%package kerberos
Summary:       ApacheDS Kerberos

%description kerberos
This package provides:
- The Kerberos protocol provider for ApacheDS.
- Interceptors used by the ApacheDS kerberos service.

%package protocols
Summary:       ApacheDS Protocols

%description protocols
This package provides the following protocols for ApacheDS:
- Change Password
- DHCP
- DNS
- LDAP
- NTP

%package server
Summary:       ApacheDS Server modules

%description server
Integration testing framework for Apache Directory Server.
The JNDI provider which launches the core and associated
network services: Changepw, Kerberos, LDAP, and NTP if
all are configured. By default only LDAP is configured
to start-up.
A multi-master replication service for replicating
information across ApacheDS instances. This service is
modeled as an interceptor.
Various command-line utilities for apacheds.
Unit testing framework for ApacheDS Server JNDI Provider.
A single authoritative server.XML file. 

%package utils
Summary:       ApacheDS Utils

%description utils
Contains utility classes for ApacheDS. 

#%% package xbean-spring
# BR/R xbean-spring maven-xbean-plugin
# BR/R springframework-beans
# BR/R springframework-context
# BR/R springframework-core 
#%% description xbean-spring

%package xdbm
Summary:       ApacheDS XDBM

%description xdbm
Base XDBM (btree based) entry store interfaces.
Search engine implementation generalized for XDBM entry
store scheme.
Generalized (X) DBM Tools:
Several kinds of two column key/value data structures, in
memory and on disk which sort keys can can be used to
implement xdbm partitions. JDBM is one example. These
partition use the same database structure or scheme for
maintaining LDAP entries and facilitating search operations
on them. This module contains common tools that could be
used to manage aspects common to all xdbm implementations. 

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q
%patch0 -p1
%patch1 -p0
chmod 644 README.txt

%pom_disable_module all
# TODO
# depend on 
# jboss jboss-system 3.2.3
# org.apache.directory.daemon daemon-bootstrappers (deceased)
# org.apache.xbean xbean-spring maven-xbean-plugin
# org.springframework spring-core spring-beans spring-context
%pom_disable_module xbean-spring
# TODO
# http-integration
# default-config
# server-sar
# server-tools
# server-xml
%pom_disable_module server-tools
%pom_disable_module server-xml
# depend on jetty 6.x
%pom_disable_module http-integration
# depend on http-integration
%pom_disable_module default-config

# this test fails
rm -rf i18n/src/test/java/org/apache/directory/server/i18n/GermanLanguageTest.java
rm -rf xdbm-search/src/test/java/org/apache/directory/server/xdbm/search/impl/LessEqTest.java

# old log4j
rm -f server-integ/src/test/java/MultiThreadedTest.java

%mvn_package ":%{name}-avl-partition" core
%mvn_package ":%{name}-core" core
%mvn_package ":%{name}-core-annotations" core
%mvn_package ":%{name}-core-api" core
%mvn_package ":%{name}-core-avl" core
%mvn_package ":%{name}-core-constants" core
%mvn_package ":%{name}-core-entry" core
%mvn_package ":%{name}-core-integ" core
%mvn_package ":%{name}-core-jndi" core
%mvn_package ":%{name}-core-mock" core
%mvn_package ":%{name}-jdbm-partition" core
%mvn_package ":%{name}-jdbm-store" core
%mvn_package ":%{name}-ldif-partition" core
%mvn_package ":%{name}-server-annotations" core
%mvn_package ":%{name}-test-framework" core
%mvn_package ":%{name}-i18n" i18n
%mvn_package ":%{name}-jdbm" jdbm
%mvn_package ":%{name}-interceptor-kerberos" kerberos
%mvn_package ":%{name}-kerberos-shared" kerberos
%mvn_package ":%{name}-kerberos-test" kerberos
%mvn_package ":%{name}-protocol-kerberos" kerberos
%mvn_package ":%{name}-protocol-changepw" protocols
%mvn_package ":%{name}-protocol-dhcp" protocols
%mvn_package ":%{name}-protocol-dns" protocols
%mvn_package ":%{name}-protocol-ldap" protocols
%mvn_package ":%{name}-protocol-ntp" protocols
%mvn_package ":%{name}-protocol-shared" protocols
%mvn_package ":%{name}-server-integ" server
%mvn_package ":%{name}-server-jndi" server
%mvn_package ":%{name}-server-replication" server
%mvn_package ":%{name}-utils" utils
%mvn_package ":%{name}-xdbm-base" xdbm
%mvn_package ":%{name}-xdbm-search" xdbm
%mvn_package ":%{name}-xdbm-tools" xdbm

%build

# server-integ fails -- -Pquicktest -Dmaven.test.failure.ignore=true
# Test disabled takes too long time 
# start Thu, 29 Jan 2015 22:12:05 UTC
# canceled Fri, 30 Jan 2015 09:26:51 UTC)
%mvn_build -s -f

%install
%mvn_install

%files -f .mfiles-%{name}-parent
%dir %{_javadir}/%{name}
%doc README.txt
%license LICENSE NOTICE

%files core -f .mfiles-core
%license LICENSE NOTICE

# files http-integration

%files i18n -f .mfiles-i18n
%license LICENSE NOTICE

%files jdbm -f .mfiles-jdbm
%license LICENSE NOTICE

%files kerberos -f .mfiles-kerberos
%license LICENSE NOTICE

%files protocols -f .mfiles-protocols
%license LICENSE NOTICE

%files server -f .mfiles-server
%license LICENSE NOTICE

%files utils -f .mfiles-utils
%license LICENSE NOTICE

# files xbean-spring 

%files xdbm -f .mfiles-xdbm
%license LICENSE NOTICE

%files javadoc -f .mfiles-javadoc
%license LICENSE NOTICE

%changelog
* Thu Jan 29 2015 gil cattaneo <puntogil@libero.it> 1.5.7-11
- introduce license macro

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5.7-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Tue May 13 2014 Michael Simacek <msimacek@redhat.com> - 1.5.7-9
- Disable tests requiring old log4j api

* Fri Mar 28 2014 Michael Simacek <msimacek@redhat.com> - 1.5.7-8
- Use Requires: java-headless rebuild (#1067528)

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5.7-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Fri Jul 05 2013 gil cattaneo <puntogil@libero.it> 1.5.7-6
- fix unowned directories

* Fri Jul 05 2013 gil cattaneo <puntogil@libero.it> 1.5.7-5
- switch to XMvn
- minor changes to adapt to current guideline

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5.7-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Feb 06 2013 Java SIG <java-devel@lists.fedoraproject.org> - 1.5.7-3
- Update for https://fedoraproject.org/wiki/Fedora_19_Maven_Rebuild
- Replace maven BuildRequires with maven-local

* Wed Aug 22 2012 gil cattaneo <puntogil@libero.it> 1.5.7-2
- Added missing deps: bouncycastle

* Sun May 20 2012 gil cattaneo <puntogil@libero.it> 1.5.7-1
- initial rpm